Index: /trunk/admin/permalinks.php
===================================================================
--- /trunk/admin/permalinks.php	(revision 4324)
+++ /trunk/admin/permalinks.php	(revision 4325)
@@ -100,5 +100,5 @@
   LIMIT 1';
   pwg_query($query);
-  if (mysql_affected_rows()==0)
+  if (pwg_db_affected_rows()==0)
     array_push($page['errors'], 'Cannot delete the old permalink !');
 }
@@ -135,5 +135,5 @@
 $categories=array();
 $result=pwg_query($query);
-while ( $row=mysql_fetch_assoc($result) )
+while ( $row = pwg_db_fetch_assoc($result) )
 {
   $row['name'] = get_cat_display_name_cache( $row['uppercats'] );
@@ -163,5 +163,5 @@
 $result = pwg_query($query);
 $deleted_permalinks=array();
-while ( $row=mysql_fetch_assoc($result) )
+while ( $row = pwg_db_fetch_assoc($result) )
 {
   $row['name'] = get_cat_display_name_cache($row['cat_id']);
Index: /trunk/admin/picture_modify.php
===================================================================
--- /trunk/admin/picture_modify.php	(revision 4324)
+++ /trunk/admin/picture_modify.php	(revision 4325)
@@ -45,5 +45,5 @@
   WHERE id = '.$_GET['image_id'].'
 ;';
-  list($path) = mysql_fetch_row(pwg_query($query));
+  list($path) = pwg_db_fetch_row(pwg_query($query));
   update_metadata(array($_GET['image_id'] => $path));
 
@@ -176,5 +176,5 @@
   WHERE id = '.$_GET['image_id'].'
 ;';
-$row = mysql_fetch_assoc(pwg_query($query));
+$row = pwg_db_fetch_assoc(pwg_query($query));
 
 $storage_category_id = null;
@@ -325,5 +325,5 @@
 $result = pwg_query($query);
 
-while ($row = mysql_fetch_assoc($result))
+while ($row = pwg_db_fetch_assoc($result))
 {
   $name =
@@ -418,5 +418,5 @@
   array_push($associateds, $storage_category_id);
 }
-while ($row = mysql_fetch_assoc($result))
+while ($row = pwg_db_fetch_assoc($result))
 {
   array_push($associateds, $row['id']);
Index: /trunk/admin/rating.php
===================================================================
--- /trunk/admin/rating.php	(revision 4324)
+++ /trunk/admin/rating.php	(revision 4325)
@@ -95,5 +95,5 @@
 ;';
 $result = pwg_query($query);
-while ($row = mysql_fetch_assoc($result))
+while ($row = pwg_db_fetch_assoc($result))
 {
   $users[$row['id']]=stripslashes($row['username']);
@@ -105,5 +105,5 @@
 WHERE r.element_id=i.id'. $page['user_filter'] .
 ';';
-list($nb_images) = mysql_fetch_row(pwg_query($query));
+list($nb_images) = pwg_db_fetch_row(pwg_query($query));
 
 
@@ -182,5 +182,5 @@
 $images = array();
 $result = pwg_query($query);
-while ($row = mysql_fetch_assoc($result))
+while ($row = pwg_db_fetch_assoc($result))
 {
   array_push($images, $row);
@@ -200,5 +200,5 @@
 ORDER BY date DESC;';
   $result = pwg_query($query);
-  $nb_rates = mysql_num_rows($result);
+  $nb_rates = pwg_db_num_rows($result);
 
   $tpl_image = 
@@ -215,5 +215,5 @@
    );
 
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
 
Index: /trunk/admin/site_manager.php
===================================================================
--- /trunk/admin/site_manager.php	(revision 4324)
+++ /trunk/admin/site_manager.php	(revision 4325)
@@ -99,5 +99,5 @@
   WHERE galleries_url = \''.$url.'\'
 ;';
-  $row = mysql_fetch_assoc(pwg_query($query));
+  $row = pwg_db_fetch_assoc(pwg_query($query));
   if ($row['count'] > 0)
   {
@@ -168,5 +168,5 @@
   WHERE id = '.$page['site'].'
 ;';
-  list($galleries_url) = mysql_fetch_row(pwg_query($query));
+  list($galleries_url) = pwg_db_fetch_row(pwg_query($query));
   switch($_GET['action'])
   {
@@ -237,5 +237,5 @@
 $result = pwg_query($query);
 
-while ($row = mysql_fetch_assoc($result))
+while ($row = pwg_db_fetch_assoc($result))
 {
   $is_remote = url_is_remote($row['galleries_url']);
Index: /trunk/admin/site_update.php
===================================================================
--- /trunk/admin/site_update.php	(revision 4324)
+++ /trunk/admin/site_update.php	(revision 4325)
@@ -44,5 +44,5 @@
   FROM '.SITES_TABLE.'
   WHERE id = '.$site_id;
-list($site_url) = mysql_fetch_row(pwg_query($query));
+list($site_url) = pwg_db_fetch_row(pwg_query($query));
 if (!isset($site_url))
 {
@@ -51,5 +51,5 @@
 $site_is_remote = url_is_remote($site_url);
 
-list($dbnow) = mysql_fetch_row(pwg_query('SELECT NOW();'));
+list($dbnow) = pwg_db_fetch_row(pwg_query('SELECT NOW();'));
 define('CURRENT_DATE', $dbnow);
 
@@ -186,5 +186,5 @@
   FROM '.CATEGORIES_TABLE;
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $next_rank[$row['id']] = 1;
@@ -197,5 +197,5 @@
   GROUP BY id_uppercat';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     // for the id_uppercat NULL, we write 'NULL' and not the empty string
@@ -211,5 +211,5 @@
 SELECT IF(MAX(id)+1 IS NULL, 1, MAX(id)+1) AS next_id
   FROM '.CATEGORIES_TABLE;
-  list($next_id) = mysql_fetch_row(pwg_query($query));
+  list($next_id) = pwg_db_fetch_row(pwg_query($query));
 
   // retrieve sub-directories fulldirs from the site reader
@@ -247,6 +247,6 @@
           ? 'false'
           : boolean_to_string($conf['newcat_default_uploadable']),
-        'status'      => $conf{'newcat_default_status'},
-        'visible'     => boolean_to_string($conf{'newcat_default_visible'}),
+        'status'      => $conf['newcat_default_status'],
+        'visible'     => boolean_to_string($conf['newcat_default_visible']),
         );
 
@@ -255,24 +255,24 @@
         $parent = $db_fulldirs[dirname($fulldir)];
 
-        $insert{'id_uppercat'} = $parent;
-        $insert{'uppercats'} =
-          $db_categories[$parent]['uppercats'].','.$insert{'id'};
-        $insert{'rank'} = $next_rank[$parent]++;
-        $insert{'global_rank'} =
-          $db_categories[$parent]['global_rank'].'.'.$insert{'rank'};
+        $insert['id_uppercat'] = $parent;
+        $insert['uppercats'] =
+          $db_categories[$parent]['uppercats'].','.$insert['id'];
+        $insert['rank'] = $next_rank[$parent]++;
+        $insert['global_rank'] =
+          $db_categories[$parent]['global_rank'].'.'.$insert['rank'];
         if ('private' == $db_categories[$parent]['status'])
         {
-          $insert{'status'} = 'private';
+          $insert['status'] = 'private';
         }
         if ('false' == $db_categories[$parent]['visible'])
         {
-          $insert{'visible'} = 'false';
+          $insert['visible'] = 'false';
         }
       }
       else
       {
-        $insert{'uppercats'} = $insert{'id'};
+        $insert['uppercats'] = $insert['id'];
         $insert{'rank'} = $next_rank['NULL']++;
-        $insert{'global_rank'} = $insert{'rank'};
+        $insert['global_rank'] = $insert['rank'];
       }
 
@@ -289,11 +289,11 @@
       $db_categories[$insert{'id'}] =
         array(
-          'id' => $insert{'id'},
-          'status' => $insert{'status'},
-          'visible' => $insert{'visible'},
-          'uppercats' => $insert{'uppercats'},
-          'global_rank' => $insert{'global_rank'}
+          'id' => $insert['id'],
+          'status' => $insert['status'],
+          'visible' => $insert['visible'],
+          'uppercats' => $insert['uppercats'],
+          'global_rank' => $insert['global_rank']
           );
-      $db_fulldirs[$fulldir] = $insert{'id'};
+      $db_fulldirs[$fulldir] = $insert['id'];
       $next_rank[$insert{'id'}] = 1;
     }
@@ -387,5 +387,5 @@
     AND validated = \'false\'';
     $result = pwg_query($query);
-    while ($row = mysql_fetch_assoc($result))
+    while ($row = pwg_db_fetch_assoc($result))
     {
       array_push(
@@ -403,5 +403,5 @@
 SELECT IF(MAX(id)+1 IS NULL, 1, MAX(id)+1) AS next_element_id
   FROM '.IMAGES_TABLE;
-  list($next_element_id) = mysql_fetch_row(pwg_query($query));
+  list($next_element_id) = pwg_db_fetch_row(pwg_query($query));
 
   $start = get_moment();
@@ -471,5 +471,5 @@
         $insert_links,
         array(
-          'image_id'    => $insert{'id'},
+          'image_id'    => $insert['id'],
           'category_id' => $insert['storage_category_id'],
           )
@@ -479,5 +479,5 @@
         $infos,
         array(
-          'path' => $insert{'path'},
+          'path' => $insert['path'],
           'info' => l10n('update_research_added')
           )
@@ -556,5 +556,5 @@
     $waiting_to_delete = array();
 
-    while ($row = mysql_fetch_assoc($result))
+    while ($row = pwg_db_fetch_assoc($result))
     {
       $data = array();
@@ -565,5 +565,5 @@
   WHERE storage_category_id = '.$row['storage_category_id'].'
     AND file = \''.$row['file'].'\'';
-      list($data['id']) = mysql_fetch_row(pwg_query($query));
+      list($data['id']) = pwg_db_fetch_row(pwg_query($query));
 
       foreach ($fields['update'] as $field)
Index: /trunk/admin/stats.php
===================================================================
--- /trunk/admin/stats.php	(revision 4324)
+++ /trunk/admin/stats.php	(revision 4325)
@@ -96,5 +96,5 @@
 
   $output = array();
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push($output, $row);
@@ -134,5 +134,5 @@
 $first_time_key = null;
 
-while ($row = mysql_fetch_assoc($result))
+while ($row = pwg_db_fetch_assoc($result))
 {
   $time_keys = array(
@@ -205,5 +205,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $key = sprintf('%4u', $row['year']);
Index: /trunk/admin/tags.php
===================================================================
--- /trunk/admin/tags.php	(revision 4324)
+++ /trunk/admin/tags.php	(revision 4325)
@@ -50,5 +50,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $current_name_of[ $row['id'] ] = $row['name'];
@@ -221,5 +221,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $name_of[ $row['id'] ] = $row['name'];
Index: /trunk/admin/thumbnail.php
===================================================================
--- /trunk/admin/thumbnail.php	(revision 4324)
+++ /trunk/admin/thumbnail.php	(revision 4325)
@@ -179,5 +179,5 @@
 ;';
 $result = pwg_query($query);
-while ( $row=mysql_fetch_assoc($result) )
+while ( $row=pwg_db_fetch_assoc($result) )
 {
   $basedir = preg_replace('#/*$#', '', $row['galleries_url']);
Index: /trunk/admin/upload.php
===================================================================
--- /trunk/admin/upload.php	(revision 4324)
+++ /trunk/admin/upload.php	(revision 4325)
@@ -101,5 +101,5 @@
 ;';
     $result = pwg_query($query);
-    while($row = mysql_fetch_assoc($result))
+    while($row = pwg_db_fetch_assoc($result))
     {
       $dir = get_complete_dir($row['storage_category_id']);
@@ -154,5 +154,5 @@
 $query.= ';';
 $result = pwg_query( $query );
-while ( $row = mysql_fetch_assoc( $result ) )
+while ( $row = pwg_db_fetch_assoc( $result ) )
 {
   if ( !isset( $cat_names[$row['storage_category_id']] ) )
Index: /trunk/admin/user_list.php
===================================================================
--- /trunk/admin/user_list.php	(revision 4324)
+++ /trunk/admin/user_list.php	(revision 4325)
@@ -50,5 +50,5 @@
   {
     $username = str_replace('*', '%', $_GET['username']);
-    $filter['username'] = mysql_real_escape_string($username);
+    $filter['username'] = pwg_db_real_escape_string($username);
   }
 
@@ -116,5 +116,5 @@
 
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $user = $row;
@@ -140,5 +140,5 @@
 ;';
     $result = pwg_query($query);
-    while ($row = mysql_fetch_assoc($result))
+    while ($row = pwg_db_fetch_assoc($result))
     {
       array_push(
@@ -493,5 +493,5 @@
 $result = pwg_query($query);
 
-while ($row = mysql_fetch_assoc($result))
+while ($row = pwg_db_fetch_assoc($result))
 {
   $groups[$row['id']] = $row['name'];
Index: /trunk/admin/user_perm.php
===================================================================
--- /trunk/admin/user_perm.php	(revision 4324)
+++ /trunk/admin/user_perm.php	(revision 4325)
@@ -79,5 +79,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push($private_uppercats, $row['id']);
@@ -96,5 +96,5 @@
   $result = pwg_query($query);
 
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push($authorized_ids, $row['cat_id']);
@@ -156,8 +156,8 @@
 $result = pwg_query($query);
 
-if (mysql_num_rows($result) > 0)
+if (pwg_db_num_rows($result) > 0)
 {
   $cats = array();
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     array_push($cats, $row);
@@ -192,5 +192,5 @@
 $result = pwg_query($query_true);
 $authorized_ids = array();
-while ($row = mysql_fetch_assoc($result))
+while ($row = pwg_db_fetch_assoc($result))
 {
   array_push($authorized_ids, $row['id']);
Index: /trunk/comments.php
===================================================================
--- /trunk/comments.php	(revision 4324)
+++ /trunk/comments.php	(revision 4325)
@@ -284,5 +284,5 @@
     AND ', $page['where_clauses']).'
 ;';
-list($counter) = mysql_fetch_row(pwg_query($query));
+list($counter) = pwg_db_fetch_row(pwg_query($query));
 
 $url = PHPWG_ROOT_PATH
@@ -332,5 +332,5 @@
 ;';
 $result = pwg_query($query);
-while ($row = mysql_fetch_assoc($result))
+while ($row = pwg_db_fetch_assoc($result))
 {
   array_push($comments, $row);
@@ -349,5 +349,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $elements[$row['id']] = $row;
Index: /trunk/feed.php
===================================================================
--- /trunk/feed.php	(revision 4324)
+++ /trunk/feed.php	(revision 4325)
@@ -76,5 +76,5 @@
   WHERE id = \''.$feed_id.'\'
 ;';
-  $feed_row = mysql_fetch_assoc(pwg_query($query));
+  $feed_row = pwg_db_fetch_assoc(pwg_query($query));
   if ( empty($feed_row) )
   {
@@ -98,5 +98,5 @@
 check_status(ACCESS_GUEST);
 
-list($dbnow) = mysql_fetch_row(pwg_query('SELECT NOW();'));
+list($dbnow) = pwg_db_fetch_row(pwg_query('SELECT NOW();'));
 
 include_once(PHPWG_ROOT_PATH.'include/feedcreator.class.php');
Index: /trunk/include/calendar_monthly.class.php
===================================================================
--- /trunk/include/calendar_monthly.class.php	(revision 4324)
+++ /trunk/include/calendar_monthly.class.php	(revision 4325)
@@ -232,5 +232,5 @@
   $result = pwg_query($query);
   $items=array();
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $y = substr($row['period'], 0, 4);
@@ -284,5 +284,5 @@
   $result = pwg_query($query);
   $items=array();
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $m = (int)substr($row['period'], 0, 2);
@@ -334,5 +334,5 @@
   $items=array();
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $d = (int)$row['period'];
@@ -352,5 +352,5 @@
     unset ( $page['chronology_date'][CDAY] );
 
-    $row = mysql_fetch_assoc(pwg_query($query));
+    $row = pwg_db_fetch_assoc(pwg_query($query));
     $items[$day]['tn_url'] = get_thumbnail_url($row);
     $items[$day]['file'] = $row['file'];
Index: /trunk/include/category_cats.inc.php
===================================================================
--- /trunk/include/category_cats.inc.php	(revision 4324)
+++ /trunk/include/category_cats.inc.php	(revision 4325)
@@ -76,5 +76,5 @@
 $image_ids = array();
 
-while ($row = mysql_fetch_assoc($result))
+while ($row = pwg_db_fetch_assoc($result))
 {
   $row['is_child_date_last'] = @$row['max_date_last']>@$row['date_last'];
@@ -109,7 +109,7 @@
 ;';
       $subresult = pwg_query($query);
-      if (mysql_num_rows($subresult) > 0)
+      if (pwg_db_num_rows($subresult) > 0)
       {
-        list($image_id) = mysql_fetch_row($subresult);
+        list($image_id) = pwg_db_fetch_row($subresult);
       }
     }
@@ -137,7 +137,7 @@
   ;';
       $subresult = pwg_query($query);
-      if (mysql_num_rows($subresult) > 0)
+      if (pwg_db_num_rows($subresult) > 0)
       {
-        list($image_id) = mysql_fetch_row($subresult);
+        list($image_id) = pwg_db_fetch_row($subresult);
       }
     }
@@ -179,5 +179,5 @@
 ;';
     $result = pwg_query($query);
-    while ($row = mysql_fetch_assoc($result))
+    while ($row = pwg_db_fetch_assoc($result))
     {
       $dates_of_category[ $row['category_id'] ] = array(
@@ -203,5 +203,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $thumbnail_src_of[$row['id']] = get_thumbnail_url($row);
Index: /trunk/include/category_default.inc.php
===================================================================
--- /trunk/include/category_default.inc.php	(revision 4324)
+++ /trunk/include/category_default.inc.php	(revision 4325)
@@ -46,5 +46,5 @@
 ;';
   $result = pwg_query($query);
-  while ($row = mysql_fetch_assoc($result))
+  while ($row = pwg_db_fetch_assoc($result))
   {
     $row['rank'] = $rank_of[ $row['id'] ];
Index: /trunk/include/common.inc.php
===================================================================
--- /trunk/include/common.inc.php	(revision 4324)
+++ /trunk/include/common.inc.php	(revision 4325)
@@ -93,4 +93,5 @@
 include(PHPWG_ROOT_PATH . 'include/config_default.inc.php');
 @include(PHPWG_ROOT_PATH. 'include/config_local.inc.php');
+include(PHPWG_ROOT_PATH .'include/dblayer/functions_mysql.inc.php');
 
 if(isset($conf['show_php_errors']) && !empty($conf['show_php_errors']))
@@ -105,20 +106,9 @@
 
 // Database connection
-@mysql_connect( $conf['db_host'], $conf['db_user'], $conf['db_password'] ) or my_error( 'mysql_connect', true );
-@mysql_select_db( $conf['db_base'] ) or my_error( 'mysql_select_db', true );
-
-defined('PWG_CHARSET') and defined('DB_CHARSET')
-  or fatal_error('PWG_CHARSET and/or DB_CHARSET is not defined');
-if ( version_compare(mysql_get_server_info(), '4.1.0', '>=') )
-{
-  if (DB_CHARSET!='')
-  {
-    pwg_query('SET NAMES "'.DB_CHARSET.'"');
-  }
-}
-elseif ( strtolower(PWG_CHARSET)!='iso-8859-1' )
-{
-  fatal_error('PWG supports only iso-8859-1 charset on MySql version '.mysql_get_server_info());
-}
+$pwg_db_link = pwg_db_connect($conf['db_host'], $conf['db_user'], 
+			      $conf['db_password'], $conf['db_base']) 
+  or my_error('pwg_db_connect', true);
+
+pwg_db_check_charset();
 
 load_conf_from_db();
Index: /trunk/include/dblayer/functions_mysql.inc.php
===================================================================
--- /trunk/include/dblayer/functions_mysql.inc.php	(revision 4325)
+++ /trunk/include/dblayer/functions_mysql.inc.php	(revision 4325)
@@ -0,0 +1,463 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based picture gallery                                  |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2008-2009 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+/**
+ *
+ * simple functions
+ *
+ */
+
+function pwg_db_connect($host, $user, $password, $database)
+{  
+  $link = mysql_connect($host, $user, $password) or my_error('mysql_connect', true);
+  mysql_select_db($database, $link) or my_error('mysql_select_db', true);
+
+  return $link;
+}
+
+function pwg_db_check_charset() 
+{
+  defined('PWG_CHARSET') and defined('DB_CHARSET')
+    or fatal_error('PWG_CHARSET and/or DB_CHARSET is not defined');
+  if ( version_compare(mysql_get_server_info(), '4.1.0', '>=') )
+  {
+    if (DB_CHARSET!='')
+    {
+      pwg_query('SET NAMES "'.DB_CHARSET.'"');
+    }
+  }
+  elseif ( strtolower(PWG_CHARSET)!='iso-8859-1' )
+  {
+    fatal_error('PWG supports only iso-8859-1 charset on MySql version '.mysql_get_server_info());
+  }
+}
+
+function pwg_get_db_version() 
+{
+  list($mysql_version) = pwg_db_fetch_row(pwg_query('SELECT VERSION();'));
+  
+  return $mysql_version;
+}
+
+function pwg_query($query)
+{
+  global $conf,$page,$debug,$t2;
+
+  $start = get_moment();
+  ($result = mysql_query($query)) or my_error($query, $conf['die_on_sql_error']);
+
+  $time = get_moment() - $start;
+
+  if (!isset($page['count_queries']))
+  {
+    $page['count_queries'] = 0;
+    $page['queries_time'] = 0;
+  }
+
+  $page['count_queries']++;
+  $page['queries_time']+= $time;
+
+  if ($conf['show_queries'])
+  {
+    $output = '';
+    $output.= '<pre>['.$page['count_queries'].'] ';
+    $output.= "\n".$query;
+    $output.= "\n".'(this query time : ';
+    $output.= '<b>'.number_format($time, 3, '.', ' ').' s)</b>';
+    $output.= "\n".'(total SQL time  : ';
+    $output.= number_format($page['queries_time'], 3, '.', ' ').' s)';
+    $output.= "\n".'(total time      : ';
+    $output.= number_format( ($time+$start-$t2), 3, '.', ' ').' s)';
+    if ( $result!=null and preg_match('/\s*SELECT\s+/i',$query) )
+    {
+      $output.= "\n".'(num rows        : ';
+      $output.= mysql_num_rows($result).' )';
+    }
+    elseif ( $result!=null
+      and preg_match('/\s*INSERT|UPDATE|REPLACE|DELETE\s+/i',$query) )
+    {
+      $output.= "\n".'(affected rows   : ';
+      $output.= mysql_affected_rows().' )';
+    }
+    $output.= "</pre>\n";
+
+    $debug .= $output;
+  }
+
+  return $result;
+}
+
+function pwg_db_changes($result) 
+{
+  return mysql_affected_rows($result);
+}
+
+function pwg_db_num_rows($result) 
+{
+  return mysql_num_rows($result);
+}
+
+function pwg_db_fetch_assoc($result)
+{
+  return mysql_fetch_assoc($result);
+}
+
+function pwg_db_fetch_row($result)
+{
+  return mysql_fetch_row($result);
+}
+
+function pwg_db_fetch_object($result)
+{
+  return mysql_fetch_object($result);
+}
+
+function pwg_free_result($result) 
+{
+  return mysql_free_result($result);
+}
+
+function pwg_db_real_escape_string($s)
+{
+  return mysql_real_escape_string($s);
+}
+
+function pwg_db_insert_id()
+{
+  return mysql_insert_id();
+}
+
+/**
+ *
+ * complex functions
+ *
+ */
+
+/**
+ * creates an array based on a query, this function is a very common pattern
+ * used here
+ *
+ * @param string $query
+ * @param string $fieldname
+ * @return array
+ */
+function array_from_query($query, $fieldname)
+{
+  $array = array();
+
+  $result = pwg_query($query);
+  while ($row = mysql_fetch_assoc($result))
+  {
+    array_push($array, $row[$fieldname]);
+  }
+
+  return $array;
+}
+
+define('MASS_UPDATES_SKIP_EMPTY', 1);
+/**
+ * updates multiple lines in a table
+ *
+ * @param string table_name
+ * @param array dbfields
+ * @param array datas
+ * @param int flags - if MASS_UPDATES_SKIP_EMPTY - empty values do not overwrite existing ones
+ * @return void
+ */
+function mass_updates($tablename, $dbfields, $datas, $flags=0)
+{
+  if (count($datas) == 0)
+    return;
+  // depending on the MySQL version, we use the multi table update or N update queries
+  if (count($datas) < 10 or version_compare(mysql_get_server_info(), '4.0.4') < 0)
+  { // MySQL is prior to version 4.0.4, multi table update feature is not available
+    foreach ($datas as $data)
+    {
+      $query = '
+UPDATE '.$tablename.'
+  SET ';
+      $is_first = true;
+      foreach ($dbfields['update'] as $key)
+      {
+        $separator = $is_first ? '' : ",\n    ";
+
+        if (isset($data[$key]) and $data[$key] != '')
+        {
+          $query.= $separator.$key.' = \''.$data[$key].'\'';
+        }
+        else
+        {
+          if ($flags & MASS_UPDATES_SKIP_EMPTY )
+            continue; // next field
+          $query.= "$separator$key = NULL";
+        }
+        $is_first = false;
+      }
+      if (!$is_first)
+      {// only if one field at least updated
+        $query.= '
+  WHERE ';
+        $is_first = true;
+        foreach ($dbfields['primary'] as $key)
+        {
+          if (!$is_first)
+          {
+            $query.= ' AND ';
+          }
+          if ( isset($data[$key]) )
+          {
+            $query.= $key.' = \''.$data[$key].'\'';
+          }
+          else
+          {
+            $query.= $key.' IS NULL';
+          }
+          $is_first = false;
+        }
+        pwg_query($query);
+      }
+    } // foreach update
+  } // if mysql_ver or count<X
+  else
+  {
+    // creation of the temporary table
+    $query = '
+SHOW FULL COLUMNS FROM '.$tablename;
+    $result = pwg_query($query);
+    $columns = array();
+    $all_fields = array_merge($dbfields['primary'], $dbfields['update']);
+    while ($row = pwg_db_fetch_assoc($result))
+    {
+      if (in_array($row['Field'], $all_fields))
+      {
+        $column = $row['Field'];
+        $column.= ' '.$row['Type'];
+
+        $nullable = true;
+        if (!isset($row['Null']) or $row['Null'] == '' or $row['Null']=='NO')
+        {
+          $column.= ' NOT NULL';
+          $nullable = false;
+        }
+        if (isset($row['Default']))
+        {
+          $column.= " default '".$row['Default']."'";
+        }
+        elseif ($nullable)
+        {
+          $column.= " default NULL";
+        }
+        if (isset($row['Collation']) and $row['Collation'] != 'NULL')
+        {
+          $column.= " collate '".$row['Collation']."'";
+        }
+        array_push($columns, $column);
+      }
+    }
+
+    $temporary_tablename = $tablename.'_'.micro_seconds();
+
+    $query = '
+CREATE TABLE '.$temporary_tablename.'
+(
+  '.implode(",\n  ", $columns).',
+  UNIQUE KEY the_key ('.implode(',', $dbfields['primary']).')
+)';
+
+    pwg_query($query);
+    mass_inserts($temporary_tablename, $all_fields, $datas);
+    if ( $flags & MASS_UPDATES_SKIP_EMPTY )
+      $func_set = create_function('$s', 'return "t1.$s = IFNULL(t2.$s, t1.$s)";');
+    else
+      $func_set = create_function('$s', 'return "t1.$s = t2.$s";');
+
+    // update of images table by joining with temporary table
+    $query = '
+UPDATE '.$tablename.' AS t1, '.$temporary_tablename.' AS t2
+  SET '.
+      implode(
+        "\n    , ",
+        array_map($func_set,$dbfields['update'])
+        ).'
+  WHERE '.
+      implode(
+        "\n    AND ",
+        array_map(
+          create_function('$s', 'return "t1.$s = t2.$s";'),
+          $dbfields['primary']
+          )
+        );
+    pwg_query($query);
+    $query = '
+DROP TABLE '.$temporary_tablename;
+    pwg_query($query);
+  }
+}
+
+
+/**
+ * inserts multiple lines in a table
+ *
+ * @param string table_name
+ * @param array dbfields
+ * @param array inserts
+ * @return void
+ */
+function mass_inserts($table_name, $dbfields, $datas)
+{
+  if (count($datas) != 0)
+  {
+    $first = true;
+
+    $query = 'SHOW VARIABLES LIKE \'max_allowed_packet\'';
+    list(, $packet_size) = pwg_db_fetch_row(pwg_query($query));
+    $packet_size = $packet_size - 2000; // The last list of values MUST not exceed 2000 character*/
+    $query = '';
+
+    foreach ($datas as $insert)
+    {
+      if (strlen($query) >= $packet_size)
+      {
+        pwg_query($query);
+        $first = true;
+      }
+
+      if ($first)
+      {
+        $query = '
+INSERT INTO '.$table_name.'
+  ('.implode(',', $dbfields).')
+  VALUES';
+        $first = false;
+      }
+      else
+      {
+        $query .= '
+  , ';
+      }
+
+      $query .= '(';
+      foreach ($dbfields as $field_id => $dbfield)
+      {
+        if ($field_id > 0)
+        {
+          $query .= ',';
+        }
+
+        if (!isset($insert[$dbfield]) or $insert[$dbfield] === '')
+        {
+          $query .= 'NULL';
+        }
+        else
+        {
+          $query .= "'".$insert[$dbfield]."'";
+        }
+      }
+      $query .= ')';
+    }
+    Log::getInstance()->debug($query);
+    pwg_query($query);
+  }
+}
+
+/**
+ * Do maintenance on all PWG tables
+ *
+ * @return none
+ */
+function do_maintenance_all_tables()
+{
+  global $prefixeTable, $page;
+
+  $all_tables = array();
+
+  // List all tables
+  $query = 'SHOW TABLES LIKE \''.$prefixeTable.'%\'';
+  $result = pwg_query($query);
+  while ($row = pwg_db_fetch_assoc($result))
+  {
+    array_push($all_tables, $row[0]);
+  }
+
+  // Repair all tables
+  $query = 'REPAIR TABLE '.implode(', ', $all_tables);
+  $mysql_rc = pwg_query($query);
+
+  // Re-Order all tables
+  foreach ($all_tables as $table_name)
+  {
+    $all_primary_key = array();
+
+    $query = 'DESC '.$table_name.';';
+    $result = pwg_query($query);
+    while ($row = pwg_db_fetch_assoc($result))
+    {
+      if ($row['Key'] == 'PRI')
+      {
+        array_push($all_primary_key, $row['Field']);
+      }
+    }
+
+    if (count($all_primary_key) != 0)
+    {
+      $query = 'ALTER TABLE '.$table_name.' ORDER BY '.implode(', ', $all_primary_key).';';
+      $mysql_rc = $mysql_rc && pwg_query($query);
+    }
+  }
+
+  // Optimize all tables
+  $query = 'OPTIMIZE TABLE '.implode(', ', $all_tables);
+  $mysql_rc = $mysql_rc && pwg_query($query);
+  if ($mysql_rc)
+  {
+    array_push(
+          $page['infos'],
+          l10n('Optimizations completed')
+          );
+  }
+  else
+  {
+    array_push(
+          $page['errors'],
+          l10n('Optimizations errors')
+          );
+  }
+}
+
+// my_error returns (or send to standard output) the message concerning the
+// error occured for the last mysql query.
+function my_error($header, $die)
+{
+  $error = "[mysql error ".mysql_errno().'] '.mysql_error()."\n";
+  $error .= $header;
+
+  if ($die)
+  {
+    fatal_error($error);
+  }
+  echo("<pre>");
+  trigger_error($error, E_USER_WARNING);
+  echo("</pre>");
+}
+
+?>
